#define led_pin 8
#include <Buzzer.h>

Buzzer buzzer(10, 13);

int pressureSensor;
bool playerMayThrow;

const int buttonPin = 2;
int buttonState = 0;

///////////////////////////////////////////////////////////////////////////////////////////////////

void setup() 
{
  pinMode(led_pin, OUTPUT);
  
  pinMode(buttonPin, INPUT_PULLUP);                 
  Serial.begin(9600);
  playerMayThrow = false; //upon connecting the Arduino to power supply; the player may not throw yet (first the player must press the button). 
}

///////////////////////////////////////////////////////////////////////////////////////////////////

void loop() 
{ 
  blinkingLED();
  buttonState = digitalRead(buttonPin);
  pressureSensor = 1023 - analogRead(A0);

  if (buttonState == LOW && playerMayThrow == false) //if the button is pressed and thus on (buttonState == LOW) while playerMayThrow = false; then the player may begin their throw. 
  {   
    playerMayThrow = true;
    Serial.println("player may Throw");
  }

  if (pressureSensor <= 1020 && playerMayThrow == true) //if the pressure sensor <= 1020 (which means it has been pressed), the victory sound will play and playerMayThrow is false again. 
  {
    Serial.println("Target has been hit");  
    playerMayThrow = false; 
    victorySound();
  }
}

///////////////////////////////////////////////////////////////////////////////////////////////////

void blinkingLED() //controls visual feedback for the player with the LED-light.
{
    if (playerMayThrow == true)
    {
      digitalWrite(led_pin, HIGH); //LED-light turns on when player is allowed to throw. 
    }
    
    if (playerMayThrow == false)
    {
      digitalWrite(led_pin, LOW); //LED-light turns on when player isn't allowed to throw. 
    }    
}

void victorySound() //plays a mario victory sound when the lucky block is hit
{ 
  buzzer.begin(100);

  buzzer.sound(NOTE_E7, 80);
  buzzer.sound(NOTE_E7, 80);
  buzzer.sound(0, 80);
  buzzer.sound(NOTE_E7, 80);
  buzzer.sound(0, 80);
  buzzer.sound(NOTE_C7, 80);
  buzzer.sound(NOTE_E7, 80);
  buzzer.sound(0, 80);
  buzzer.sound(NOTE_G7, 80);
  buzzer.sound(0, 240);
  buzzer.sound(NOTE_G6, 80);
  buzzer.sound(0, 240);

  buzzer.end(100);
}